using System;

namespace Model
{
	/// <summary>
	/// All information that is needed to represent the identification of a user.
	/// This information acts as the users passport, and is sent remotely for validation/security purposes.
	/// </summary>	
	[Serializable] 
	public class UserIdentity 
	{
		public String Name;
		public String Password;
		public String SecretQuestion="";
		public String SecretAnswer="";

		public UserIdentity(string iniName,string iniPwd)
		{
			Name=iniName;Password=iniPwd;
			this.SecretAnswer=this.SecretQuestion="";
		}

		public UserIdentity():this("","")
		{
		}

		/// <summary>
		/// User with blank password
		/// </summary>
		/// <param name="iniName"></param>
		public UserIdentity(string iniName):this(iniName,"")
		{
			
		}

	}
}
